#pragma once

#include <stdint.h>

namespace Voltmeter
{
    class Button
    {
        public:

            constexpr Button(int16_t longPressTimeMs, bool multipleLongPresses = false)
                : longPressTimeMs(longPressTimeMs)
                , multipleLongPresses(multipleLongPresses)
                , initialized(false)
                , lastState(false)
                , pressTimeMs(-1)
                , longPressActive(false)
                , returnLongPress(false)
                , returnShortPress(false)
            {}

            void SetState(bool state, int32_t currentTimeMs);
            bool WasPressed();
            bool WasLongPressed();
        
        private:

            int16_t longPressTimeMs;
            bool multipleLongPresses;
            bool initialized;
            bool lastState;
            int32_t pressTimeMs;

            bool longPressActive;
            bool returnLongPress;
            bool returnShortPress;
    };
}