#pragma once

#include <stdint.h>
#include "measurement.hpp"


namespace Voltmeter
{
    class Measurer
    {
        public:

            Measurer();

            bool HasMeasurement();
            Measurement GetMeasurement();

            void Configure(uint16_t const samplesN);
            void SetRange(Range const range);
            void AddSample(uint16_t const sample);

        private:


            volatile bool isResultReady;
            Measurement currentResult;

            Measurement nextResult;
            uint16_t sampleIndex;

            Voltmeter::Range pendingRange;
            uint16_t pendingSamplesN;

            bool switchRange;
    };
}